
/*********************/
/* 8. ̺   */
/*********************/


/* -------------------------------
       <ǽ1> p360 ~ p365
---------------------------------*/

USE master;
CREATE DATABASE tableDB;

-- ⼭  (p365)

USE tableDB
DBCC CHECKIDENT('buyTbl')

DBCC CHECKIDENT('buyTbl',RESEED, 0)


/* -------------------------------
       <ǽ2> p367 ~ p371
---------------------------------*/

USE master
DROP DATABASE tableDB
GO
CREATE DATABASE tableDB

USE tableDB
CREATE TABLE userTbl -- ȸ̺
( userID  nchar(8) , -- ̵
  name    nvarchar(10) , -- ̸
  birthYear   int ,  -- ⵵
  addr	  nchar(4) , -- 
  mobile1	nchar(3), -- ޴Ǳ
  mobile2   nchar(8), -- ޴ǳȭȣ
height    smallint  -- 
)
CREATE TABLE buyTbl -- ̺
(  num int , -- 
   userid  nchar(8), --̵
   prodName nchar(6), -- ǰ
   groupName nchar(4), -- з
   price     int, -- ܰ
   amount    smallint -- 
)

USE master
CREATE DATABASE nullDB
GO
ALTER DATABASE nullDB
	SET ANSI_NULL_DEFAULT OFF --  ص ⺻ OFF
GO
USE nullDB
CREATE TABLE t1 (id int)
GO
INSERT INTO t1 VALUES (NULL)

EXEC sp_help t1

USE master
DROP DATABASE nullDB
GO
CREATE DATABASE nullDB
GO
ALTER DATABASE nullDB
	SET ANSI_NULL_DEFAULT OFF --   ص ⺻ OFF
GO
SET ANSI_NULL_DFLT_ON OFF 
USE nullDB
CREATE TABLE t1 (id int)
GO
INSERT INTO t1 VALUES (NULL)

USE master
DROP DATABASE nullDB

USE tableDB
DROP TABLE userTbl, buyTbl
GO
CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL ,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)
CREATE TABLE buyTbl
(  num int NOT NULL,
   userid  nchar(8) NOT NULL,
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)

DROP TABLE buyTbl
GO
CREATE TABLE buyTbl
(  num int IDENTITY(1,1) NOT NULL,
   userid  nchar(8) NOT NULL,
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)

DROP TABLE userTbl, buyTbl
GO
CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)
CREATE TABLE buyTbl
(  num int IDENTITY(1,1) NOT NULL PRIMARY KEY,
   userid  nchar(8) NOT NULL,
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)

DROP TABLE  buyTbl
GO
CREATE TABLE buyTbl
(  num int IDENTITY(1,1) NOT NULL PRIMARY KEY,
   userid  nchar(8) NOT NULL
		FOREIGN KEY REFERENCES userTbl(userID) ,
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)

INSERT INTO userTbl VALUES(N'PJS', N'', 1983, N'', N'011', N'1111111', 181)
INSERT INTO userTbl VALUES(N'PJY', N'ֿ', 1986, N'', N'011', N'2222222', 178)
INSERT INTO userTbl VALUES(N'JJJ', N'', 1986, N'', N'019', N'3333333', 179)

INSERT INTO buyTbl VALUES(N'PJY', N'ȭ', NULL   , 30,   2)
INSERT INTO buyTbl VALUES(N'PJY', N'Ʈ', N'', 1000, 1)
INSERT INTO buyTbl VALUES(N'LCS', N'', N'', 200,  1)


-----------------
-- P372 ~ P382
-----------------

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL 
		CONSTRAINT PK_userID PRIMARY KEY ,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)

EXEC sp_help userTbl

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL ,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)
GO
ALTER TABLE userTbl
	ADD CONSTRAINT PK_userID
	PRIMARY KEY (userID)
GO

CREATE TABLE prodTbl
( prodCode NCHAR(3) NOT NULL,
  prodID   NCHAR(4)  NOT NULL,
  prodDate SMALLDATETIME  NOT NULL,
  prodCur  NCHAR(10) NULL
)
GO
ALTER TABLE prodTbl
	ADD CONSTRAINT PK_proCode_prodID 
	PRIMARY KEY (prodCode, prodID) 
GO

CREATE TABLE prodTbl
( prodCode NCHAR(3) NOT NULL,
  prodID   NCHAR(4)  NOT NULL,
  prodDate SMALLDATETIME  NOT NULL,
  prodCur  NCHAR(10) NULL,
  CONSTRAINT PK_proCode_prodID 
	PRIMARY KEY (prodCode, prodID) 
)

DROP TABLE userTbl
CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY ,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)
GO

CREATE TABLE buyTbl
(  num int NOT NULL PRIMARY KEY,
   userid  nchar(8) NOT NULL
		FOREIGN KEY REFERENCES userTbl(userID) ,
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)

CREATE TABLE buyTbl
(  num int NOT NULL PRIMARY KEY,
   userid  nchar(8) NOT NULL 
		CONSTRAINT FK_userTbl_buyTbl FOREIGN KEY
		   REFERENCES userTbl(userID),
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY ,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL
)
GO
CREATE TABLE buyTbl
(  num int NOT NULL PRIMARY KEY,
   userid  nchar(8) NOT NULL ,
   prodName nchar(6) NOT NULL,
   groupName nchar(4)  NULL,
   price     int NOT NULL,
   amount    smallint NOT NULL
)
GO
ALTER TABLE buyTbl
	ADD CONSTRAINT FK_userTbl_buyTbl
	FOREIGN KEY (userID)
	REFERENCES userTbl (userID)

ALTER TABLE buyTbl
	ADD CONSTRAINT FK_userTbl_buyTbl
	FOREIGN KEY (userID)
	REFERENCES userTbl (userID)
	ON UPDATE CASCADE

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL,
  email   nchar(30) NULL  UNIQUE
)

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL,
  email   nchar(30) NULL  
	CONSTRAINT AK_email  UNIQUE
)

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL,
  addr	  nchar(4) NOT NULL,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL,
  email   nchar(30) NULL ,  
	CONSTRAINT AK_email  UNIQUE (email)
)

ALTER TABLE userTbl
	ADD CONSTRAINT CK_birthYear
	CHECK  
          (birthYear >= 1900 AND birthYear <= YEAR(GETDATE()))         

ALTER TABLE userTbl
	ADD CONSTRAINT CK_mobile1
	CHECK  
          (mobile1 IN ('010','011','016','017','018','019'))

ALTER TABLE userTbl
	ADD CONSTRAINT CK_height
	CHECK  
       (height >= 0)

ALTER TABLE userTbl
    WITH NOCHECK
	ADD CONSTRAINT CK_mobile1
	CHECK  
          (mobile1 IN ('010','011','016','017','018','019'))

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL DEFAULT YEAR(GETDATE()),
  addr	  nchar(4) NOT NULL DEFAULT '' ,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL DEFAULT 170
)

CREATE TABLE userTbl 
( userID  nchar(8) NOT NULL PRIMARY KEY,
  name    nvarchar(10) NOT NULL,
  birthYear   int NOT NULL ,
  addr	  nchar(4) NOT NULL  ,
  mobile1	nchar(3) NULL,
  mobile2   nchar(8) NULL,
  height    smallint  NULL 
)
GO
ALTER TABLE userTbl
	ADD CONSTRAINT CD_birthYear
		DEFAULT YEAR(GETDATE()) FOR birthYear
GO
ALTER TABLE userTbl
	ADD CONSTRAINT CD_addr
		DEFAULT '' FOR addr
GO
ALTER TABLE userTbl
	ADD CONSTRAINT CD_height
		DEFAULT 170 FOR height
GO

-- default DEFAULT  ڵԷѴ.
INSERT INTO userTbl VALUES('WJN','糲',default,default,'019','1231234',default)

-- ̸ õ  DEFAULT Ȱ ڵԷѴ
INSERT INTO userTbl(userID,name) VALUES('WJW','')

--   Ǹ DEFAULT   õȴ.
INSERT INTO userTbl VALUES('HJY','ֿ',1975,'õ','017','7777777',169)


/* -------------------------------
       <ǽ3> p383 ~ p385
̹ ǽ â  ʿϹǷ, 
縦 ؼ Ʒ SQL  â ؾ .
---------------------------------*/

USE tableDB
CREATE TABLE #tempTbl (ID  INT,  txt NVARCHAR(10))
GO
CREATE TABLE ##tempTbl (ID  INT,  txt NVARCHAR(10))
GO

INSERT INTO #tempTbl VALUES(1, 'ӽ̺')
INSERT INTO ##tempTbl VALUES(2, 'ӽ̺')
GO

SELECT * FROM #tempTbl 
SELECT * FROM ##tempTbl

USE master
SELECT * FROM #tempTbl 
SELECT * FROM ##tempTbl

SELECT * FROM ##tempTbl

SELECT * FROM #tempTbl

BEGIN TRAN
	INSERT INTO ##tempTbl VALUES (2, 'Է')

SELECT * FROM #tempTbl

COMMIT TRAN
SELECT * FROM ##tempTbl


-----------------
-- P387 ~ P389
-----------------

USE tableDB
ALTER TABLE userTbl
	ADD homepage NVARCHAR(30)  -- ߰
		DEFAULT 'http://www.hanbitbook.co.kr' -- Ʈ
		NULL -- Null 

ALTER TABLE userTbl
	DROP COLUMN mobile1

-- ⼭ 
USE tableDB
EXEC sp_rename 'userTbl.name', 'username', 'COLUMN'

ALTER TABLE userTbl
	ALTER COLUMN name  NVARCHAR(20) NULL

ALTER TABLE userTbl
	DROP CONSTRAINT CD_height


/* -------------------------------
       <ǽ4> p389 ~ p398
---------------------------------*/

USE tableDB
DROP TABLE buyTbl, userTbl
GO
CREATE TABLE userTbl 
( userID  nchar(8) ,
  name    nvarchar(10) ,
  birthYear   int  ,
  addr	  nchar(4)   ,
  mobile1	nchar(3) ,
  mobile2   nchar(8) ,
  height    smallint   
)
GO
CREATE TABLE buyTbl
(  num int   IDENTITY,
   userid  nchar(8),
   prodName nchar(6),
   groupName nchar(4),
   price     int,
   amount    smallint
)
GO

INSERT INTO userTbl VALUES(N'PJS', N'', 1983, N'', N'011', N'1111111', 181)
INSERT INTO userTbl VALUES(N'PJY', N'ֿ', NULL, N'', N'011', N'2222222', 178)
INSERT INTO userTbl VALUES(N'JJJ', N'', 1886, N'', N'019', N'3333333', 179)
INSERT INTO userTbl VALUES(N'LCS', N'õ', 1983, N'õ', N'011', N'4444444', 179)
GO
INSERT INTO buyTbl VALUES(N'PJY', N'ȭ', NULL   , 30,   2)
INSERT INTO buyTbl VALUES(N'PJY', N'Ʈ', N'', 1000, 1)
INSERT INTO buyTbl VALUES(N'LCS', N'', N'', 200,  1)
INSERT INTO buyTbl VALUES(N'CJC', N'', N'', 200,  5)
GO

ALTER TABLE userTbl
	ADD CONSTRAINT PK_userID
	PRIMARY KEY (userID)

ALTER TABLE userTbl
	ALTER COLUMN userID	NCHAR(8) NOT NULL
GO
ALTER TABLE userTbl
	ADD CONSTRAINT PK_userID
	   PRIMARY KEY (userID)
GO
ALTER TABLE buyTbl
	ADD CONSTRAINT PK_num
	   PRIMARY KEY (num)

ALTER TABLE buyTbl
	ADD CONSTRAINT FK_userTbl_buyTbl
		FOREIGN KEY (userID)
		REFERENCES userTbl (userID)

ALTER TABLE buyTbl WITH NOCHECK
	ADD CONSTRAINT FK_userTbl_buyTbl
		FOREIGN KEY (userID)
		REFERENCES userTbl (userID)

INSERT INTO buyTbl VALUES(N'PJY', N'û', N'Ƿ', 50,   3)

INSERT INTO buyTbl VALUES(N'CJC', N'޸', N'', 80,  10)

ALTER TABLE buyTbl 
	NOCHECK CONSTRAINT FK_userTbl_buyTbl
GO
INSERT INTO buyTbl VALUES(N'CJC', N'޸', N'', 80,  10)
INSERT INTO buyTbl VALUES(N'AJH', N'å'    , N'', 15,   5)
INSERT INTO buyTbl VALUES(N'SKH', N'å'    , N'', 15,   2)
INSERT INTO buyTbl VALUES(N'SKH', N'û', N'Ƿ', 50,   1)
INSERT INTO buyTbl VALUES(N'CJC', N'ȭ', NULL   , 30,   2)
INSERT INTO buyTbl VALUES(N'SKH', N'å'    , N'', 15,   1)
INSERT INTO buyTbl VALUES(N'CJC', N'ȭ', NULL   , 30,   2)
GO
ALTER TABLE buyTbl 
	CHECK CONSTRAINT FK_userTbl_buyTbl
GO

ALTER TABLE userTbl
	ADD CONSTRAINT CK_birthYear
	CHECK  
          (birthYear >= 1900 AND birthYear <= YEAR(GETDATE()))

ALTER TABLE userTbl
    WITH NOCHECK
	ADD CONSTRAINT CK_birthYear
	CHECK  
          (birthYear >= 1900 AND birthYear <= YEAR(GETDATE()))

INSERT INTO userTbl VALUES(N'AJH', N'ȯ', 1979, N'', NULL  , NULL      , 182)
INSERT INTO userTbl VALUES(N'KNI', N'賲', 1977, N'', N'016', N'6666666', 183)
INSERT INTO userTbl VALUES(N'LYP', N'̿ǥ', 1983, N'', NULL  , NULL      , 178)
INSERT INTO userTbl VALUES(N'SKH', N'', 1978, N'', N'011', N'8888888', 182)
INSERT INTO userTbl VALUES(N'SJK', N'', 1979, N'', N'018', N'9999999', 178)
INSERT INTO userTbl VALUES(N'CJC', N'ö', 1975, N'', N'019', N'0000000', 185)

UPDATE userTbl SET userID = 'CCC' WHERE userID='CJC'

ALTER TABLE buyTbl 
	NOCHECK CONSTRAINT FK_userTbl_buyTbl
GO
UPDATE userTbl SET userID = 'CCC' WHERE userID='CJC'
GO
ALTER TABLE buyTbl 
	CHECK CONSTRAINT FK_userTbl_buyTbl

SELECT B.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM buyTbl B
  INNER JOIN userTbl U
     ON B.userid = U.userid

SELECT COUNT(*) FROM buyTbl

SELECT B.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM buyTbl B
  LEFT OUTER JOIN userTbl U
     ON B.userid = U.userid
  ORDER BY B.userid

ALTER TABLE buyTbl 
	NOCHECK CONSTRAINT FK_userTbl_buyTbl
GO
UPDATE userTbl SET userID = 'CJC' WHERE userID='CCC'
GO
ALTER TABLE buyTbl 
	CHECK CONSTRAINT FK_userTbl_buyTbl

ALTER TABLE buyTbl
	DROP CONSTRAINT FK_userTbl_buyTbl
GO
ALTER TABLE buyTbl WITH NOCHECK
	ADD CONSTRAINT FK_userTbl_buyTbl
		FOREIGN KEY (userID)
		REFERENCES userTbl (userID)
		ON UPDATE CASCADE
GO

UPDATE userTbl SET userID = 'CCC' WHERE userID='CJC'
GO
SELECT B.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM buyTbl B
  INNER JOIN userTbl U
     ON B.userid = U.userid
  ORDER BY B.userid

DELETE userTbl WHERE userID = 'CCC'

ALTER TABLE buyTbl
	DROP CONSTRAINT FK_userTbl_buyTbl
GO
ALTER TABLE buyTbl WITH NOCHECK
	ADD CONSTRAINT FK_userTbl_buyTbl
		FOREIGN KEY (userID)
		REFERENCES userTbl (userID)
		ON UPDATE CASCADE
		ON DELETE CASCADE
GO

DELETE userTbl WHERE userID = 'CCC'
GO
SELECT * FROM buyTbl

ALTER TABLE userTbl
	DROP COLUMN birthYear

ALTER TABLE userTbl
	DROP CK_birthYear
GO
ALTER TABLE userTbl
	DROP COLUMN birthYear
GO


-----------------
-- P399 ~ P400
-----------------

SELECT * FROM BRAIN.tableDB.dbo.userTbl

USE tableDB
SELECT * FROM userTbl

USE AdventureWorks
CREATE TABLE aaa (id int)
GO
CREATE TABLE HumanResources.aaa (id int)
GO


/* -------------------------------
       <ǽ5> p401 ~ p402
---------------------------------*/

CREATE DATABASE tableDB2
GO
USE tableDB2
CREATE TABLE userTbl2 (id int, txt nchar(10))
GO
INSERT INTO userTbl2 VALUES(1, '̰Ǽ弭')

EXEC sp_addlinkedserver   
   @server='SECOND', --   ̸(ϴ ̸ )
   @srvproduct='SQLServer',  --   . SQL Server '' ᵵ .
   @provider='SQLNCLI', -- SQL Native Client 
   @datasrc='BRAIN\SECOND' --   νϽ

SELECT * FROM SECOND.tableDB2.dbo.userTbl2

EXEC sp_dropserver 'SECOND'


-----------------
-- P403 ~ P405
-----------------

CREATE VIEW v_userTbl
AS
	SELECT userid, name, addr FROM userTbl
GO
SELECT * FROM v_userTbl  -- 並 ̶̺ ص 

SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
FROM userTbl U
  INNER JOIN buyTbl B
     ON U.userid = B.userid 

CREATE VIEW v_userbuyTbl
AS
  SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS [ó]
  FROM userTbl U
	INNER JOIN buyTbl B
	 ON U.userid = B.userid

SELECT * FROM v_userbuyTbl WHERE name = 'ֿ'


/* -------------------------------
       <ǽ6> p406 ~ p412
---------------------------------*/

USE master
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE

USE sqlDB
GO
CREATE VIEW v_userbuyTbl
AS
SELECT U.userid AS [USER ID], U.name AS [USER NAME], 
		B.prodName AS [PRODUCT NAME], 
		U.addr, U.mobile1 + U.mobile2  AS [MOBILE PHONE]
FROM userTbl U
	INNER JOIN buyTbl B
	 ON U.userid = B.userid
GO
SELECT [USER ID],[USER NAME] FROM v_userbuyTbl

ALTER VIEW v_userbuyTbl
AS
SELECT U.userid AS [ھ̵], U.name AS [̸], 
		B.prodName AS [ǰ̸], 
		U.addr, U.mobile1 + U.mobile2  AS [ȭȣ]
FROM userTbl U
	INNER JOIN buyTbl B
	 ON U.userid = B.userid
GO
select [̸],[ȭȣ] FROM v_userbuyTbl

DROP VIEW v_userbuyTbl

USE sqlDB
GO
CREATE VIEW v_userTbl
AS
	SELECT userid, name, addr FROM userTbl

SELECT * FROM sys.sql_modules

SELECT OBJECT_NAME(object_id), definition FROM sys.sql_modules

ALTER VIEW v_userTbl
	WITH ENCRYPTION
AS
	SELECT userid, name, addr FROM userTbl
GO

SELECT OBJECT_NAME(object_id), definition FROM sys.sql_modules

UPDATE v_userTbl SET addr = 'λ' WHERE userid='AJH'

INSERT INTO v_userTbl(userid, name, addr) VALUES('WJW','','')

CREATE VIEW v_sum
AS
	SELECT userid AS [userid], SUM(price*amount) AS [total]  
	FROM buyTbl GROUP BY userid
GO
SELECT * FROM v_sum

CREATE VIEW v_height180
AS
	SELECT * FROM userTbl WHERE height >= 180
GO
SELECT * FROM v_height180

DELETE v_height180 WHERE height < 180

INSERT INTO v_height180 VALUES(N'WJW', N'', 2003 , N'', N'015', N'5555555', 178)

ALTER VIEW v_height180
AS
	SELECT * FROM userTbl WHERE height >= 180
	WITH CHECK OPTION
GO
INSERT INTO v_height180 VALUES(N'WDT', N'', 2006 , N'', N'013', N'3333333', 177)

CREATE VIEW v_userbuyTbl
AS
SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2 AS mobile
FROM userTbl U
	INNER JOIN buyTbl B
	 ON U.userid = B.userid
GO
INSERT INTO v_userbuyTbl VALUES('WWW','','ȭ','','00000000000')

DROP TABLE buyTbl, userTbl

select * from v_userbuyTbl

USE master
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE
GO
USE sqlDB
GO
CREATE VIEW v_userTbl
AS
	SELECT userid, name, addr FROM userTbl

EXEC sp_depends userTbl


/* -------------------------------
       <ǽ7> p415 ~ p420
̹ ǽ 3    ؾ ϹǷ,
縦 ؼ Ʒ SQL   â  .
---------------------------------*/

CREATE DATABASE partViewDB
GO
USE partViewDB
CREATE TABLE userTbl -- ̺
( userID  nchar(8) NOT NULL , 
  name    nvarchar(10) NOT NULL, 
  birthYear   int NOT NULL,  
  addr	  nchar(4) NOT NULL 
			 CHECK (addr = ''), 
  mobile1	nchar(3), 
  mobile2   nchar(8), 
  height    smallint,
  CONSTRAINT pk_userid_addr
      PRIMARY KEY (userid, addr) 
)

CREATE DATABASE partViewDB
GO
USE partViewDB
CREATE TABLE userTbl -- ̺
( userID  nchar(8) NOT NULL , 
  name    nvarchar(10) NOT NULL, 
  birthYear   int NOT NULL, 
  addr	  nchar(4) NOT NULL
			 CHECK (addr = ''), 
  mobile1	nchar(3), 
  mobile2   nchar(8), 
  height    smallint,
  CONSTRAINT pk_userid_addr
      PRIMARY KEY (userid, addr) 
)

CREATE DATABASE partViewDB
GO
USE partViewDB
CREATE TABLE userTbl -- ̺
( userID  nchar(8) NOT NULL , 
  name    nvarchar(10) NOT NULL, 
  birthYear   int NOT NULL, 
  addr	  nchar(4) NOT NULL
			CHECK (addr <> '' AND addr <> ''), --,   
  mobile1	nchar(3), 
  mobile2   nchar(8), 
  height    smallint,
  CONSTRAINT pk_userid_addr
      PRIMARY KEY (userid, addr) 
)

EXEC sp_addlinkedserver   
   @server='SECOND', 
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN\SECOND' -- ڿ ڰ ٸ

EXEC sp_addlinkedserver   
   @server='THIRD', 
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN\THIRD' -- ڿ ڰ ٸ

EXEC sp_addlinkedserver   
   @server='BRAIN', -- ڿ͵ڰٸ
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN' -- ڿ͵ڰٸ

EXEC sp_addlinkedserver   
   @server='THIRD', 
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN\THIRD' -- ڿ͵ڰٸ

EXEC sp_addlinkedserver   
   @server='BRAIN', -- ڿ͵ڰٸ
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN' -- ڿ͵ڰٸ

EXEC sp_addlinkedserver   
   @server='SECOND', 
   @srvproduct='SQLServer', 
   @provider='SQLNCLI', 
   @datasrc='BRAIN\SECOND' -- ڿ ڰ ٸ

CREATE VIEW dpv_userTbl AS  -- dpv distributed partitioned view ڸ 
      SELECT * FROM partViewDB.dbo.userTbl
UNION ALL
      SELECT * FROM SECOND.partViewDB.dbo.userTbl
UNION ALL
      SELECT * FROM THIRD.partViewDB.dbo.userTbl

CREATE VIEW dpv_userTbl AS
   SELECT * FROM BRAIN.partViewDB.dbo.userTbl
UNION ALL
   SELECT * FROM partViewDB.dbo.userTbl
UNION ALL
  SELECT * FROM THIRD.partViewDB.dbo.userTbl

CREATE VIEW dpv_userTbl AS
      SELECT * FROM BRAIN.partViewDB.dbo.userTbl
UNION ALL
   SELECT * FROM SECOND.partViewDB.dbo.userTbl
UNION ALL
   SELECT * FROM partViewDB.dbo.userTbl

SET XACT_ABORT ON

INSERT INTO dpv_userTbl VALUES(N'PJS', N'', 1983, N'', N'011', N'1111111', 181)
INSERT INTO dpv_userTbl VALUES(N'PJY', N'ֿ', 1986, N'', N'011', N'2222222', 178)
INSERT INTO dpv_userTbl VALUES(N'JJJ', N'', 1986, N'', N'019', N'3333333', 179)
INSERT INTO dpv_userTbl VALUES(N'LCS', N'õ', 1983, N'õ', N'011', N'4444444', 179)
INSERT INTO dpv_userTbl VALUES(N'AJH', N'ȯ', 1979, N'', NULL  , NULL      , 182)
INSERT INTO dpv_userTbl VALUES(N'KNI', N'賲', 1977, N'', N'016', N'6666666', 183)
INSERT INTO dpv_userTbl VALUES(N'LYP', N'̿ǥ', 1983, N'', NULL  , NULL      , 178)
INSERT INTO dpv_userTbl VALUES(N'SKH', N'', 1978, N'', N'011', N'8888888', 182)
INSERT INTO dpv_userTbl VALUES(N'SJK', N'', 1979, N'', N'018', N'9999999', 178)
INSERT INTO dpv_userTbl VALUES(N'CJC', N'ö', 1975, N'', N'019', N'0000000', 185)

select * from userTbl

SELECT * FROM dpv_userTbl


/* -------------------------------
       <ǽ8> p422 ~ p427
---------------------------------*/

USE master
CREATE DATABASE partTblDB 
ON  PRIMARY  -- 75(75)
( NAME = partTblDB, 
FILENAME = N'C:\ϵũC\partTblDB.mdf' 
),
FILEGROUP YEAR_76_80 -- 76~80
( NAME = partTblDB2,
FILENAME = N'C:\ϵũD\partTblDB2.ndf'  
),
FILEGROUP YEAR_81 -- 81(81)
( NAME = partTblDB3,
FILENAME = N'C:\ϵũE\partTblDB3.ndf'  
)
 LOG ON -- α
( NAME = partTblDB_log, -- α
FILENAME = N'C:\ϵũF\partTblDB_log.ldf'  
)

USE partTblDB
GO
CREATE PARTITION FUNCTION birtyYearRangePF (INT)
	AS RANGE LEFT FOR VALUES (1975, 1981)

CREATE PARTITION SCHEME birtyYearRangePS
AS PARTITION birtyYearRangePF
TO ( [PRIMARY], YEAR_76_80, YEAR_81)
GO

CREATE TABLE userTbl
( userID  nchar(8) NOT NULL , 
  name    nvarchar(10) NOT NULL, 
  birthYear   int NOT NULL,  
  addr	  nchar(4) NOT NULL, 
  mobile1	nchar(3), 
  mobile2   nchar(8), 
  height    smallint
) ON birtyYearRangePS (birthYear)

USE master
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE

USE partTblDB
INSERT INTO userTbl 
	SELECT * FROM sqlDB.dbo.userTbl

SELECT * FROM userTBL

SELECT * FROM userTbl
WHERE $PARTITION.birtyYearRangePF(birthYear) = 1    -- Ƽ ȣ

CREATE TABLE noPart_userTbl
( userID  nchar(8) NOT NULL , 
  name    nvarchar(10) NOT NULL, 
  birthYear   int NOT NULL,  
  addr	  nchar(4) NOT NULL, 
  mobile1	nchar(3), 
  mobile2   nchar(8), 
  height    smallint
) ON YEAR_81

ALTER TABLE userTbl SWITCH PARTITION 3 TO noPart_userTbl

SELECT * FROM userTbl

SELECT * FROM noPart_userTbl

INSERT INTO userTbl 
	SELECT * FROM noPart_userTbl
GO
DROP TABLE noPart_userTbl


