
/*****************/
/* 13. Ʈ  */
/*****************/

/* -------------------------------
       <ǽ1> p623 ~ p624
---------------------------------*/

USE tempdb;
CREATE TABLE testTbl (id INT, txt NVARCHAR(5));
GO
INSERT INTO testTbl VALUES(1, '糲');
INSERT INTO testTbl VALUES(2, '');
INSERT INTO testTbl VALUES(3, 'ֿ');

CREATE TRIGGER testTrg  -- Ʈ ̸
ON testTbl -- ƮŸ  ̺
AFTER  DELETE, UPDATE  -- ,Ŀ ۵ϵ 
AS
	PRINT('ƮŰ ۵߽ϴ') ; -- Ʈ  ۵Ǵ ڵ

INSERT INTO testTbl VALUES(4, '');
UPDATE testTbl SET txt = '' WHERE id = 2;
DELETE testTbl WHERE id = 4;


/* -------------------------------
       <ǽ2> p626 ~ p628
---------------------------------*/

USE master ;
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE ;

USE sqlDB;
DROP TABLE buyTbl; -- ̺ ʿǷ .
CREATE TABLE backup_userTbl
( userID  nchar(8) , 
  name    nvarchar(10) , 
  birthYear   int , 
  addr	  nchar(4) , 
  mobile1	nchar(3), 
  mobile2   nchar(8), 
  height    smallint ,
  modType  NCHAR(2), --  Ÿ. '' Ǵ ''
  modDate  datetime, --  ¥
  modUser  nvarchar(256) --  
)

CREATE TRIGGER trg_BackupUserTbl  -- Ʈ ̸
ON userTbl -- ƮŸ  ̺
AFTER  UPDATE,DELETE  -- , Ŀ ۵ϵ 
AS
	DECLARE @modType NCHAR(2) --  Ÿ

	IF (COLUMNS_UPDATED() > 0) -- Ʈ Ǿٸ
		BEGIN
			SET @modType = ''
		END
	ELSE -- Ǿٸ,
		BEGIN
			SET @modType = ''
		END
	-- delete ̺ ( ) ̺ 
	INSERT INTO backup_userTbl 
		SELECT userID, name, birthYear, addr, mobile1, mobile2,
				height, @modType, GETDATE(), USER_NAME() FROM deleted

UPDATE userTbl SET addr = '̱' WHERE userID = 'JJJ';
DELETE userTbl WHERE height >= 180;

SELECT * FROM backup_userTbl;

TRUNCATE TABLE userTbl;

SELECT * FROM backup_userTbl;

CREATE TRIGGER trg_insertUserTbl
ON userTbl 
AFTER  INSERT  --  Ŀ ۵ϵ 
AS
	RAISERROR(N' Է õ߽ϴ.',10,1)
    RAISERROR(N'   ϵǾϴ.',10,1)
	RAISERROR(N'׸, Է ʹ  ʾҽϴ.',10,1)
	ROLLBACK TRAN;

INSERT INTO userTbl VALUES(N'ABC', N'', 1977, N'', N'011', N'1111111', 181)


/* -------------------------------
       <ǽ3> p630 ~ p635
---------------------------------*/

USE master ;
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE ;

USE sqlDB;
GO
CREATE VIEW uv_deliver --   
AS
	SELECT b.userid, u.name, b.prodName, b.price, b.amount, u.addr
	FROM buyTbl b
		INNER JOIN userTbl u
		ON b.userid = u.userid;

SELECT * FROM uv_deliver;

INSERT INTO uv_deliver VALUES ('DTI', '', '', 50, 1, 'õ')

CREATE TRIGGER trg_insert
ON uv_deliver
INSTEAD OF INSERT
AS
BEGIN
	INSERT INTO userTbl(userid, name, birthYear, addr)
		SELECT userid, name, 1900 , addr FROM inserted

	INSERT INTO buyTbl(userid, prodName, price, amount)
		SELECT userid, prodName, price, amount FROM inserted
END;

INSERT INTO uv_deliver VALUES ('SYJ', '', '', 50, 1, '')

SELECT * FROM userTbl WHERE userid = 'DTI';
SELECT * FROM buyTbl WHERE userid = 'DTI';

EXEC sp_helptrigger uv_deliver;

EXEC sp_helptext trg_insert;

EXEC sp_rename 'dbo.trg_insert', 'dbo.trg_uvInsert' ;

DROP TRIGGER dbo.trg_uvInsert;

SELECT * FROM sys.sql_modules ;

DROP VIEW uv_deliver;


/* -------------------------------
       <ǽ4> p637 ~ p640
---------------------------------*/

USE master ;
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE ;

USE sqlDB;
GO
CREATE TRIGGER ddlTrg_sqlDB
	ON DATABASE
	AFTER DROP_TABLE, ALTER_TABLE
AS
	PRINT ' : ̺ ϰų ϴ  Ǿ ֽϴ.'
	ROLLBACK TRANSACTION;

DROP TABLE buyTbl;

DROP TABLE userTbl;

ALTER TRIGGER ddlTrg_sqlDB
	ON DATABASE
	AFTER DDL_TABLE_VIEW_EVENTS
AS
	PRINT ' :  ̺//ε  ,, Ǿϴ.'
	ROLLBACK TRANSACTION;

CREATE TABLE prodTbl (prodID INT, prodName NVARCHAR(20));

DISABLE TRIGGER ddlTrg_sqlDB ON DATABASE;

ENABLE TRIGGER ddlTrg_sqlDB ON DATABASE;

CREATE TRIGGER ddlTrg_server
	ON ALL SERVER
	AFTER CREATE_DATABASE, ALTER_DATABASE, DROP_DATABASE
AS
	PRINT ' : ͺ̽ õ ۾ ڿ ϼ.'
	ROLLBACK TRANSACTION;

CREATE DATABASE testDB;

DROP TRIGGER ddlTrg_server ON ALL SERVER;

USE sqlDB;
DROP TRIGGER ddlTrg_sqlDB ON DATABASE;

-- ⼭  (P645)
EXEC sp_configure 'nested triggers', 0
RECONFIGURE;

/* -------------------------------
       <ǽ5> p644 ~ p650
---------------------------------*/

USE master;
CREATE DATABASE triggerDB;

USE triggerDB;
CREATE TABLE orderTbl --  ̺
	(orderNo INT IDENTITY, --  Ϸùȣ
        userID NVARCHAR(5), --  ȸ̵
	 prodName NVARCHAR(5), --  
	 orderAmount INT );  --  
GO
CREATE TABLE prodTbl -- ǰ ̺
	( prodName NVARCHAR(5), --  ̸
	  account INT ); --  Ǽ
GO
CREATE TABLE deliverTbl --  ̺
	( deliverNo  INT IDENTITY, --  Ϸùȣ
	  prodName NVARCHAR(5), --  		  
	  amount INT ); --  ǰ

INSERT INTO prodTbl VALUES('', 100);
INSERT INTO prodTbl VALUES('', 100);
INSERT INTO prodTbl VALUES('', 100);

CREATE TABLE recuA  (id INT IDENTITY, txt NVARCHAR(10)); --  Ʈſ ̺A
GO
CREATE TABLE recuB  (id INT IDENTITY, txt NVARCHAR(10)); --  Ʈſ ̺B
GO
CREATE TABLE recuAA (id INT IDENTITY, txt NVARCHAR(10)); --  Ʈſ ̺AA

EXEC sp_configure 'nested triggers'

-- ǰ̺  ҽŰ Ʈ
CREATE TRIGGER trg_order 
ON orderTbl 
AFTER  INSERT 
AS
	PRINT '1. trg_order մϴ.'
	DECLARE @orderAmount INT
	DECLARE @prodName NVARCHAR(5)
	SELECT @orderAmount = orderAmount FROM inserted
	SELECT @prodName = prodName FROM inserted
	UPDATE prodTbl SET account = account - @orderAmount 
		WHERE prodName = @prodName ;
GO

-- ̺    Էϴ Ʈ
CREATE TRIGGER trg_prod 
ON prodTbl 
AFTER  UPDATE 
AS
	PRINT '2. trg_prod մϴ.'
	DECLARE @prodName NVARCHAR(5)
	DECLARE @amount INT
	SELECT @prodName = prodName FROM inserted
	SELECT @amount = D.account - I.account
		FROM inserted I, deleted D  -- ǰ- ǰ = ֹ
	INSERT INTO deliverTbl(prodName,amount)  VALUES(@prodName, @amount); 

INSERT INTO orderTbl VALUES ('JOHN','',5);

SELECT * FROM orderTbl;
SELECT * FROM prodTbl;
SELECT * FROM deliverTbl;

EXEC sp_rename 'dbo.deliverTbl.prodName', 'productName', 'COLUMN';

INSERT INTO orderTbl VALUES ('DANG','',9);

SELECT * FROM orderTbl;
SELECT * FROM prodTbl;
SELECT * FROM deliverTbl;

USE triggerDB;
SELECT name, is_recursive_triggers_on FROM sys.databases
	WHERE name = 'triggerDB';

ALTER DATABASE triggerDB
	SET RECURSIVE_TRIGGERS ON;

CREATE TRIGGER trg_recuA 
ON recuA 
AFTER  INSERT 
AS
	DECLARE @id INT
	SELECT @id = trigger_nestlevel() --  Ʈ 
	PRINT 'Ʈŷ==> ' + CAST(@id AS CHAR(5))
	INSERT INTO recuB VALUES ('Ʈ')
GO

CREATE TRIGGER trg_recuB 
ON recuB 
AFTER  INSERT 
AS
	DECLARE @id INT
	SELECT @id = trigger_nestlevel() --  Ʈ 
	PRINT 'Ʈŷ==> ' + CAST(@id AS CHAR(5))
	INSERT INTO recuA VALUES ('Ʈ')

INSERT INTO recuA VALUES ('óԷ°');

select * from recuA;
select * from recuB;

ALTER TRIGGER trg_recuA 
ON recuA 
AFTER  INSERT 
AS
	IF ( (SELECT trigger_nestlevel() ) >= 32 )
		RETURN
	DECLARE @id INT
	SELECT @id = trigger_nestlevel() -- Ʈŷ
	PRINT 'Ʈŷ==> ' + CAST(@id AS CHAR(5))
	INSERT INTO recuB VALUES ('Ʈ')
GO

ALTER TRIGGER trg_recuB 
ON recuB 
AFTER  INSERT 
AS
	IF ( (SELECT trigger_nestlevel() ) >= 32 )
		RETURN
	DECLARE @id INT
	SELECT @id = trigger_nestlevel() -- Ʈŷ
	PRINT 'Ʈŷ==> ' + CAST(@id AS CHAR(5))
	INSERT INTO recuA VALUES ('Ʈ')

INSERT INTO recuA VALUES ('óԷ°');

select * from recuA;
select * from recuB;

