
/*************************************/
/* 19. SQL Server 2005   */
/*************************************/


/* -------------------------------
       <ǽ1> p908 ~ p914
---------------------------------*/

USE master;
RESTORE DATABASE sqlDB FROM DISK ='c:\sqldb.bak' WITH REPLACE;

USE sqlDB;
GO
CREATE VIEW uv_userbuyTbl
AS
SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS phone
FROM userTbl U
	INNER JOIN buyTbl B
	 ON U.userid = B.userid;


/* -------------------------------
       <ǽ2> p915 ~ p923
---------------------------------*/

USE [sqlDB3]
GO
/****** ü:  Table [dbo].[userTbl]    ũƮ¥: 10/03/2006 19:17:26 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[guestTbl](
	[userID] [nchar](8) COLLATE Korean_Wansung_CI_AS NOT NULL,
	[name] [nvarchar](10) COLLATE Korean_Wansung_CI_AS NOT NULL,
--()[birthYear] [int] NOT NULL, 
	[addr] [nchar](4) COLLATE Korean_Wansung_CI_AS NOT NULL,
	[mobile1] [nchar](3) COLLATE Korean_Wansung_CI_AS NULL,
	[mobile2] [nchar](8) COLLATE Korean_Wansung_CI_AS NULL,
	[hobby] [nvarchar] (20) NULL, --  
PRIMARY KEY CLUSTERED 
(
	[userID] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]

USE [sqlDB3]
GO
/****** ü:  Table [dbo].[buyTbl]    ũƮ¥: 10/03/2006 19:33:32 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[orderTbl](
	[num] [int] IDENTITY(1,1) NOT NULL,
	[userid] [nchar](8) COLLATE Korean_Wansung_CI_AS NOT NULL,
	[prodName] [nchar](6) COLLATE Korean_Wansung_CI_AS NOT NULL,
	[groupName] [nchar](4) COLLATE Korean_Wansung_CI_AS NULL,
	[price] [int] NOT NULL,
	[amount] [smallint] NOT NULL,
PRIMARY KEY CLUSTERED 
(
	[num] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]

GO
/* ߿ 
ALTER TABLE [dbo].[orderTbl]  WITH CHECK ADD FOREIGN KEY([userid])
REFERENCES [dbo].[guestTbl] ([userID])
*/

USE sqlDB;
SELECT * FROM sys.views;

EXEC sp_helptext uv_userbuyTbl;

USE sqlDB3;
GO
CREATE VIEW uv_guestorderTbl
AS
SELECT U.userid, U.name, B.prodName, U.addr, U.mobile1 + U.mobile2  AS phone
FROM guestTbl U
	INNER JOIN orderTbl B
	 ON U.userid = B.userid;
GO

USE master;
CREATE DATABASE sqlDB3;

USE sqlDB3;
SELECT * FROM guestTbl;
SELECT * FROM orderTbl;

ALTER TABLE [dbo].[orderTbl]  WITH CHECK ADD FOREIGN KEY([userid])
REFERENCES [dbo].[guestTbl] ([userID])


